---
title: Clients.matchAll()
slug: Web/API/Clients/matchAll
tags:
  - API
  - Clients
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <strong><code>matchAll()</code></strong> method of the {{domxref("Clients")}} interface returns a {{jsxref("Promise")}} for a list of service worker {{domxref("Client")}} objects. Include the <code style="font-style: normal;">options</code> parameter to return all service worker clients whose origin is the same as the associated service worker's origin. If options are not included, the method returns only the service worker clients controlled by the service worker.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">self.clients.matchAll(<em>options</em>).then(function(<em>clients</em>) {
  // do something with your clients list
});</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An options object allowing you to set options for the matching operation. Available options are:
 <ul>
  <li><code>includeUncontrolled</code>: A {{jsxref("Boolean")}} — if set to <code>true</code>, the matching operation will return all service worker clients who share the same origin as the current service worker. Otherwise, it returns only the service worker clients controlled by the current service worker. The default is <code>false</code>.</li>
  <li><code>type</code>: Sets the type of clients you want matched. Available values are <code>"window"</code>, <code>"worker"</code>, <code>"sharedworker"</code>, and <code>"all"</code>. The default is <code>"window"</code>.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to an array of {{domxref("Client")}} objects. In Chrome 46/Firefox 54 and later, this method returns clients in most recently focused order, correct as per spec.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">clients.matchAll(options).then(function(clientList) {
  for (var i = 0 ; i &lt; clientList.length ; i++) {
    if (clientList[i].url === 'index.html') {
      clients.openWindow(clientList[i]);
      // or do something else involving the matching client
    }
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#clients-matchall', 'Clients: matchall')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Clients.matchAll")}}</p>
</div>
